<template>
    <v-container fluid>
        <v-row align="center">
            <v-col class="d-flex" cols="12" sm="2">
                <v-select :items="departements" item-text="text" item-value="value" label="Sélectionner un département"
                          v-model="departementSelected">
                </v-select>
            </v-col>
            <v-col class="d-flex" cols="12" sm="2">
                <v-select :items="itemSelectStatus" item-text="text" item-value="value" label="Statut du départ"
                          v-model="statusSelected">
                </v-select>
            </v-col>
            <v-col class="d-flex" cols="12" sm="2">
                <v-select :items="departs" item-text="name" item-value="id" label="Sélectionner un départ"
                          v-model="departSelected">
                </v-select>
            </v-col>
            <v-col class="d-flex" cols="12" sm="2" offset="5">
<!--                <v-btn v-if="!displayMap" :to="{name: 'map', params: {depart: departSelected}}">Display map</v-btn>-->
                <v-btn v-if="!displayDetail" v-on:click="toggleDetail">Display Detail</v-btn>
                <v-btn v-if="!displayList" v-on:click="toggleList">Display List</v-btn>
            </v-col>
            <v-col cols="12" sm="11">
                <keep-alive>
                    <TablePoint v-if="displayList" :points="points"
                    />
                    <DetailDepart v-if="displayDetail" :points="points"
                    />
                </keep-alive>
            </v-col>
        </v-row>

        <v-speed-dial
                :absolute=true
                :fixed=true
                :bottom="true"
                :right="true"
                :open-on-hover="true"
                direction="left"
        >
            <template v-slot:activator>
                <v-btn color="green darken-4" dark fab>
                    <v-icon>cloud_download</v-icon>
                </v-btn>
            </template>
            <v-btn fab dark medium color="green darken-4">
                V2
            </v-btn>
            <v-btn fab dark medium color="green darken-4">
                Tous
            </v-btn>
        </v-speed-dial>
    </v-container>
</template>

<script>
    import axios from "axios";
    import TablePoint from "../components/table_point";
    import DetailDepart from "../components/detail_depart";

    export default {
        name: "DepartsDisplay",
        components: {TablePoint, DetailDepart},
        data: () => ({
            departs: [],
            departSelected: 0,
            points: [],
            statusSelected: 1,
            departements: [
                {text: "22", value: "22"},
                {text: "29", value: "29"},
                {text: "41", value: "41"},
            ],
            departementSelected: "22",
            itemSelectStatus: [
                {text: "Etude", value: 0},
                {text: "Travaux", value: 1},
                {text: "Archive", value: 2},
            ],
            displayDetail: false,
            displayList: true,
            displayMap: false
        }),
        watch: {
            statusSelected: {
                handler() {
                    this.fetchDeparts();
                },
                immediate: true
            },
            departementSelected: {
                handler() {
                    this.fetchDeparts();
                },
                immediate: true
            },
            departSelected: function () {
                axios.get('/departs/' + this.departSelected).then((res) => this.points = res.data.depart.points)
            }
        },
        methods: {
            fetchDeparts: function () {
                this.points = []
                axios.get('/departsFilter/' + this.departementSelected + "/" + this.statusSelected).then((res) => {
                    this.departs = res.data.departs
                })
            },
            toggleDetail: function () {
                this.displayDetail = true
                this.displayList = false
                this.displayMap = false
            },
            toggleList: function () {
                this.displayDetail = false
                this.displayList = true
                this.displayMap = false
            }
        }
    }
</script>

